Index: issm/trunk/src/c/objects/Bamg/Triangles.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/Triangles.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Triangles.h	(revision 3913)
@@ -0,0 +1,203 @@
+#ifndef _TRIANGLES_H_
+#define _TRIANGLES_H_
+
+#include "./include.h"
+#include "./BamgOpts.h"
+#include "./BamgMesh.h"
+#include "./BamgGeom.h"
+#include "./Triangle.h"
+#include "./VertexOnGeom.h"
+#include "./VertexOnVertex.h"
+#include "./VertexOnEdge.h"
+#include "./ListofIntersectionTriangles.h"
+
+
+namespace bamg {
+
+	//classes
+	class Geometry;
+	class CrackedEdge;
+	class QuadTree;
+	class SubDomain;
+
+	class Triangles {
+		public:
+
+			Geometry & Gh;   // Geometry
+			Triangles & BTh; // Background Mesh Bth==*this =>no  background 
+			long NbRef;      // counter of ref on the this class if 0 we can delete
+			long nbvx,nbtx;  // nombre max  de sommets , de  triangles
+			long nt,nbv,nbt,nbiv,nbe; // nb of legal triangles, nb of vertex, of triangles, of initial vertices, of edges with reference,
+			long NbOfQuad;  // nb of quadrangle 
+			long NbSubDomains;
+			long NbOutT;    // Nb of oudeside triangle
+			long NbOfTriangleSearchFind;
+			long NbOfSwapTriangle;
+			MeshVertex* vertices;
+			long NbVerticesOnGeomVertex;
+			VertexOnGeom * VerticesOnGeomVertex;
+			long NbVerticesOnGeomEdge;
+			VertexOnGeom * VerticesOnGeomEdge;
+			long NbVertexOnBThVertex;
+			VertexOnVertex *VertexOnBThVertex;
+			long NbVertexOnBThEdge;
+			VertexOnEdge *VertexOnBThEdge;
+			long NbCrackedVertices;
+			long* CrackedVertices;
+			long NbCrackedEdges;
+			CrackedEdge* CrackedEdges;
+			R2 pmin,pmax;    // extrema
+			double coefIcoor; // coef to integer Icoor1;
+			Triangle* triangles;
+			Edge* edges; 
+			QuadTree* quadtree;
+			MeshVertex** ordre;
+			SubDomain* subdomains;
+			ListofIntersectionTriangles lIntTria;
+
+			//Constructors/Destructors
+			Triangles(BamgGeom* bamggeom,BamgMesh* bamgmesh,BamgOpts* bamgopts);
+			Triangles(double* index,double* x,double* y,int nods,int nels);
+			Triangles(Triangles &,Geometry * pGh=0,Triangles* pBTh=0,long nbvxx=0 ); //copy operator
+			Triangles(const Triangles &,const int *flag,const int *bb,BamgOpts* bamgopts); // truncature
+			Triangles(long nbvx,Triangles & BT,BamgOpts* bamgopts,int keepBackVertices=1) :Gh(BT.Gh),BTh(BT) {
+				try {GeomToTriangles1(nbvx,bamgopts,keepBackVertices);}
+				catch(...) { this->~Triangles(); throw; }
+			}
+			Triangles(long nbvx,Geometry & G,BamgOpts* bamgopts) :Gh(G),BTh(*this){
+				try { GeomToTriangles0(nbvx,bamgopts);}
+				catch(...) { this->~Triangles(); throw; }
+			}
+			~Triangles(); 
+
+			//Operators
+			const MeshVertex & operator[]  (long i) const { return vertices[i];};
+			MeshVertex & operator[](long i) { return vertices[i];};
+			const Triangle & operator()  (long i) const { return triangles[i];};
+			Triangle & operator()(long i) { return triangles[i];};
+
+			//Methods
+			void SetIntCoor(const char * from =0);
+			double MinimalHmin() {return 2.0/coefIcoor;}
+			double MaximalHmax() {return Max(pmax.x-pmin.x,pmax.y-pmin.y);}
+			I2 toI2(const R2 & P) const {
+				return  I2( (Icoor1) (coefIcoor*(P.x-pmin.x))
+							,(Icoor1) (coefIcoor*(P.y-pmin.y)) );}
+			R2 toR2(const I2 & P) const {
+				return  R2( (double) P.x/coefIcoor+pmin.x, (double) P.y/coefIcoor+pmin.y);
+			}
+			void AddVertex(MeshVertex & s,Triangle * t,Icoor2 *  =0) ;
+			void Insert();
+			void ForceBoundary();
+			void FindSubDomain(int OutSide=0);
+			long TriangleReferenceList(long*) const;
+			void TriangleIntNumbering(long* renumbering);
+			void ShowHistogram() const;
+			void CrackMesh(BamgOpts* bamgopts);
+			void ShowRegulaty() const;
+			void SmoothMetric(double raisonmax) ;
+			void BoundAnisotropy(double anisomax,double hminaniso= 1e-100) ;
+			void MaxSubDivision(double maxsubdiv);
+			Edge** MakeGeometricalEdgeToEdge();
+			long SplitInternalEdgeWithBorderVertices();
+			void MakeQuadrangles(double costheta);
+			int  SplitElement(int choice);
+			void MakeQuadTree();
+			void NewPoints(Triangles &,BamgOpts* bamgopts,int KeepVertices=1);
+			long InsertNewPoints(long nbvold,long & NbTSwap) ; 
+			void ReNumberingTheTriangleBySubDomain(bool justcompress=false);
+			void ReNumberingVertex(long * renu);
+			void SmoothingVertex(int =3,double=0.3);
+			Metric MetricAt (const R2 &) const;
+			GeometricalEdge* ProjectOnCurve( Edge & AB, MeshVertex &  A, MeshVertex & B,double theta, MeshVertex & R,VertexOnEdge & BR,VertexOnGeom & GR);
+			long Number(const Triangle & t) const  { return &t - triangles;}
+			long Number(const Triangle * t) const  { return t - triangles;}
+			long Number(const MeshVertex & t) const  { return &t - vertices;}
+			long Number(const MeshVertex * t) const  { return t - vertices;}
+			long Number(const Edge & t) const  { return &t - edges;}
+			long Number(const Edge * t) const  { return t - edges;}
+			long Number2(const Triangle * t) const  { return t - triangles; }
+			MeshVertex* NearestVertex(Icoor1 i,Icoor1 j) ;
+			Triangle* FindTriangleContaining(const I2 & ,Icoor2 [3],Triangle *tstart=0) const;
+			void ReadMesh(double* index,double* x,double* y,int nods,int nels);
+			void ReadMesh(BamgMesh* bamgmesh, BamgOpts* bamgopts);
+			void WriteMesh(BamgMesh* bamgmesh,BamgOpts* bamgopts);
+			void ReadMetric(const BamgOpts* bamgopts);
+			void WriteMetric(BamgOpts* bamgopts);
+			void AddMetric(BamgOpts* bamgopts);
+			void BuildMetric0(BamgOpts* bamgopts);
+			void BuildMetric1(BamgOpts* bamgopts);
+			void AddGeometryMetric(BamgOpts* bamgopts);
+			int  isCracked() const {return NbCrackedVertices != 0;}
+			void BuildGeometryFromMesh(BamgOpts* bamgopts=NULL);
+			void ReconstructExistingMesh();
+
+			//Inline methods
+			inline  void ReMakeTriangleContainingTheVertex(){
+				for (int i=0;i<nbv;i++) vertices[i].vint=0, vertices[i].t=NULL;
+				for (int i=0;i<nbt;i++) triangles[i].SetTriangleContainingTheVertex();
+			}
+			inline  void  UnMarkUnSwapTriangle(){
+				for (int i=0;i<nbt;i++)
+				 for(int j=0;j<3;j++)
+				  triangles[i].SetUnMarkUnSwap(j);
+			  }
+			inline  void  SetVertexFieldOn(){
+				for (int i=0;i<nbv;i++)                    vertices[i].onGeometry=NULL;
+				for (int j=0;j<NbVerticesOnGeomVertex;j++) VerticesOnGeomVertex[j].SetOn();
+				for (int k=0;k<NbVerticesOnGeomEdge;k++ )  VerticesOnGeomEdge[k].SetOn();
+			}	       
+			inline  void   SetVertexFieldOnBTh(){
+				for (int i=0;i<nbv;i++)                 vertices[i].onGeometry=NULL;
+				for (int j=0;j<NbVertexOnBThVertex;j++) VertexOnBThVertex[j].SetOnBTh();
+				for (int k=0;k<NbVertexOnBThEdge;k++ )  VertexOnBThEdge[k].SetOnBTh();
+			}
+
+		private:
+			void GeomToTriangles1(long nbvx,BamgOpts* bamgopts,int KeepVertices=1);// the real constructor mesh adaption
+			void GeomToTriangles0(long nbvx,BamgOpts* bamgopts);// the real constructor mesh generator
+			void PreInit(long);
+
+	};
+
+	/*Intermediary*/
+	TriangleAdjacent CloseBoundaryEdge(I2 ,Triangle *, double &,double &) ;
+	TriangleAdjacent CloseBoundaryEdgeV2(I2 A,Triangle *t, double &a,double &b);
+	void  swap(Triangle *t1,short a1,
+				Triangle *t2,short a2,
+				MeshVertex *s1,MeshVertex *s2,Icoor2 det1,Icoor2 det2);
+	int SwapForForcingEdge(MeshVertex   *  & pva ,MeshVertex  * &   pvb ,
+				TriangleAdjacent & tt1,Icoor2 & dets1,
+				Icoor2 & detsa,Icoor2 & detsb, int & nbswap);
+	int ForceEdge(MeshVertex &a, MeshVertex & b,TriangleAdjacent & taret) ;
+	inline TriangleAdjacent Previous(const TriangleAdjacent & ta){
+		return TriangleAdjacent(ta.t,PreviousEdge[ta.a]);
+	}
+	inline TriangleAdjacent Next(const TriangleAdjacent & ta){
+		return TriangleAdjacent(ta.t,NextEdge[ta.a]);
+	}
+	inline  TriangleAdjacent Adj(const TriangleAdjacent & a){
+		return  a.Adj();
+	}
+	inline void Adj(GeometricalEdge * & on,int &i){
+		int j=i;i=on->DirAdj[i];on=on->Adj[j];
+	}
+	inline double qualite(const MeshVertex &va,const MeshVertex &vb,const MeshVertex &vc){
+		double ret; 
+		I2 ia=va,ib=vb,ic=vc;
+		I2 ab=ib-ia,bc=ic-ib,ac=ic-ia;
+		Icoor2 deta=Det(ab,ac);
+		if (deta <=0) ret = -1;
+		else {
+			double a = sqrt((double) (ac,ac)),
+					 b = sqrt((double) (bc,bc)),
+					 c = sqrt((double) (ab,ab)),
+					 p = a+b+c;
+			double h= Max(Max(a,b),c),ro=deta/p;
+			ret = ro/h;
+		}
+		return ret;
+	}
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/VertexOnEdge.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/VertexOnEdge.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/VertexOnEdge.cpp	(revision 3913)
@@ -0,0 +1,21 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "VertexOnEdge.h"
+#include "Triangles.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+
+	/*Methods*/
+	/*FUNCTION VertexOnEdge::Set {{{1*/
+	void VertexOnEdge::Set(const Triangles & Th ,long i,Triangles & ThNew){
+		*this = Th.VertexOnBThEdge[i];  
+		v = ThNew.vertices + Th.Number(v);
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/VertexOnEdge.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/VertexOnEdge.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/VertexOnEdge.h	(revision 3913)
@@ -0,0 +1,36 @@
+#ifndef _VERTEXONEDGE_H_
+#define _VERTEXONEDGE_H_
+
+#include "./include.h"
+#include "./Edge.h"
+
+namespace bamg {
+
+	//classes
+	class Triangles;
+	class MeshVertex;
+
+	class VertexOnEdge {
+
+		public:
+			MeshVertex* v;
+			Edge*   be;
+			double abcisse;
+
+			//Constructors
+			VertexOnEdge( MeshVertex * w, Edge *bw,double s) :v(w),be(bw),abcisse(s) {}
+			VertexOnEdge(){}
+
+			//Operators
+			operator double () const { return abcisse;}
+			operator MeshVertex* () const { return v;}  
+			operator Edge* () const { return be;}  
+			MeshVertex & operator[](int i) const { return (*be)[i];}
+
+			//Methods
+			void SetOnBTh(){v->onBackgroundEdge=this;v->vint=IsVertexOnEdge;}  
+			void Set(const Triangles &,long,Triangles &);  
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/VertexOnGeom.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/VertexOnGeom.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/VertexOnGeom.cpp	(revision 3913)
@@ -0,0 +1,28 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "VertexOnGeom.h"
+#include "Triangles.h"
+#include "Geometry.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+
+	/*Methods*/
+	/*FUNCTION VertexOnGeom::Set {{{1*/
+	void VertexOnGeom::Set(const VertexOnGeom & rec,const Triangles & Th ,Triangles & ThNew){
+		*this = rec;  
+		mv = ThNew.vertices + Th.Number(mv);
+		if (gv)
+		 if (abscisse < 0 )
+		  gv = ThNew.Gh.vertices + Th.Gh.Number(gv);
+		 else
+		  ge = ThNew.Gh.edges + Th.Gh.Number(ge);
+
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/VertexOnGeom.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/VertexOnGeom.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/VertexOnGeom.h	(revision 3913)
@@ -0,0 +1,48 @@
+#ifndef _VERTEXONGEOM_H_
+#define _VERTEXONGEOM_H_
+
+#include "./include.h"
+#include "./GeometricalVertex.h"
+
+namespace bamg {
+
+	//classes
+	class Triangles;
+	class MeshVertex;
+	class GeometricalEdge;
+
+	class VertexOnGeom{
+
+		public:
+
+			MeshVertex* mv;
+			double abscisse;  
+			union{ 
+				GeometricalVertex* gv; // if abscisse <0; 
+				GeometricalEdge*   ge; // if abscisse in [0..1]
+			};
+
+			//Constructors/Destructors
+			VertexOnGeom(): mv(0),abscisse(0){gv=0;} 
+			VertexOnGeom(MeshVertex & m,GeometricalVertex &g) : mv(&m),abscisse(-1){gv=&g;}
+			VertexOnGeom(MeshVertex & m,GeometricalEdge &g,double s) : mv(&m),abscisse(s){ge=&g;}
+
+			//Operators
+			operator MeshVertex*() const  {return mv;}
+			operator GeometricalVertex * () const  {return gv;}
+			operator GeometricalEdge * () const  {return ge;}
+			operator const double & () const {return abscisse;}
+
+			//Methods
+			int  OnGeomVertex()const{return this? abscisse <0 :0;}
+			int  OnGeomEdge() const {return this? abscisse >=0 :0;}
+			int  IsRequiredVertex() {return this? ((abscisse<0 ? (gv?gv->Required():0):0 )) : 0;}
+			void SetOn(){mv->onGeometry=this;mv->vint=IsVertexOnGeom;}
+
+			//Inline methods
+			void Set(const VertexOnGeom&,const Triangles &,Triangles &);  
+
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/VertexOnVertex.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/VertexOnVertex.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/VertexOnVertex.cpp	(revision 3913)
@@ -0,0 +1,21 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "VertexOnVertex.h"
+#include "Triangles.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+
+	/*Methods*/
+	/*FUNCTION VertexOnVertex::Set{{{1*/
+	void VertexOnVertex::Set(const Triangles &Th ,long i,Triangles &ThNew) { 
+		*this = Th.VertexOnBThVertex[i];  
+		v     = ThNew.vertices + Th.Number(v);
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/VertexOnVertex.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/VertexOnVertex.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/VertexOnVertex.h	(revision 3913)
@@ -0,0 +1,28 @@
+#ifndef _VERTEXONVERTEX_H_
+#define _VERTEXONVERTEX_H_
+
+#include "./include.h"
+#include "./MeshVertex.h"
+
+namespace bamg {
+
+	//classes
+	class Triangles;
+
+	class VertexOnVertex {
+
+		public:
+			MeshVertex* v;
+			MeshVertex* bv;
+
+			//Constructors
+			VertexOnVertex(MeshVertex * w,MeshVertex *bw) :v(w),bv(bw){}
+			VertexOnVertex() {};
+
+			//Methods
+			void SetOnBTh(){v->onBackgroundVertex=bv;v->vint=IsVertexOnVertex;}
+			void Set(const Triangles &,long,Triangles &);
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/include.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/include.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/include.h	(revision 3913)
@@ -0,0 +1,14 @@
+/*!\file: include.h
+ * \brief prototypes for include.h
+ */ 
+
+#ifndef _INCLUDE2_H_
+#define  _INCLUDE2_H_
+
+
+#include "./macros.h"
+#include "./typedefs.h"
+
+
+#endif //ifndef _INCLUDE2_H_
+
Index: issm/trunk/src/c/objects/Bamg/macros.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/macros.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/macros.h	(revision 3913)
@@ -0,0 +1,29 @@
+#ifndef _BAMGMACROS_H
+#define _BAMGMACROS_H
+
+#include "./typedefs.h"
+
+namespace bamg {
+
+	const double Pi =3.141592653589793238462643383279502884197169399375105820974944592308;
+	const float  fPi=3.141592653589793238462643383279502884197169399375105820974944592308;
+	const  int   IsVertexOnGeom = 8;
+	const  int   IsVertexOnVertex = 16;
+	const  int   IsVertexOnEdge = 32;
+	static const short VerticesOfTriangularEdge[3][2] = {{1,2},{2,0},{0,1}};
+	static const short EdgesVertexTriangle[3][2] = {{1,2},{2,0},{0,1}};
+	static const short OppositeVertex[3] = {0,1,2};
+	static const short OppositeEdge[3] =  {0,1,2};
+	static const short NextEdge[3] = {1,2,0};
+	static const short PreviousEdge[3] = {2,0,1};
+	static const short NextVertex[3] = {1,2,0};
+	static const short PreviousVertex[3] = {2,0,1};
+#if LONG_BIT > 63
+	const  Icoor1 MaxICoor   = 1073741823; // 2^30-1 =111...111 (29 times)
+#else
+	const  Icoor1 MaxICoor   = 8388608;    // 2^23
+#endif
+	const  Icoor2 MaxICoor22 = Icoor2(2)*Icoor2(MaxICoor) * Icoor2(MaxICoor) ;
+}
+
+#endif
Index: issm/trunk/src/c/objects/Bamg/typedefs.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/typedefs.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/typedefs.h	(revision 3913)
@@ -0,0 +1,20 @@
+#ifndef _BAMGTYPEDEFS_H
+#define _BAMGTYPEDEFS_H
+
+#include "./R2.h"
+
+namespace bamg {
+
+	typedef int  Icoor1;  
+#if LONG_BIT > 63 //64 bits or more
+	typedef long Icoor2;
+#else //32 bits
+	typedef double Icoor2;
+#endif
+	typedef P2<Icoor1,Icoor2>  I2;
+	typedef P2xP2<short,long>  I2xI2;
+	typedef P2<double,double>  R2;
+	typedef P2<double,double>  R2xR2;
+}
+
+#endif
Index: issm/trunk/src/c/objects/DakotaPlugin.cpp
===================================================================
--- issm/trunk/src/c/objects/DakotaPlugin.cpp	(revision 3912)
+++ issm/trunk/src/c/objects/DakotaPlugin.cpp	(revision 3913)
@@ -26,5 +26,5 @@
 #include "../include/include.h"
 #include "../objects/objects.h"
-#include "../Qmux/Qmux.h"
+#include "../modules/Qmux/Qmux.h"
 
 /*Standard includes: */
Index: issm/trunk/src/c/objects/Loads/Riftfront.cpp
===================================================================
--- issm/trunk/src/c/objects/Loads/Riftfront.cpp	(revision 3912)
+++ issm/trunk/src/c/objects/Loads/Riftfront.cpp	(revision 3913)
@@ -16,5 +16,5 @@
 #include "../../shared/shared.h"
 #include "../../include/include.h"
-#include "../../ModelProcessorx/ModelProcessorx.h"
+#include "../../modules/ModelProcessorx/ModelProcessorx.h"
 #include "../objects.h"
 /*}}}*/
Index: issm/trunk/src/c/objects/Model.cpp
===================================================================
--- issm/trunk/src/c/objects/Model.cpp	(revision 3912)
+++ issm/trunk/src/c/objects/Model.cpp	(revision 3913)
@@ -12,9 +12,9 @@
 #include "stdio.h"
 #include "../DataSet/DataSet.h"
-#include "../ModelProcessorx/ModelProcessorx.h"
+#include "../modules/ModelProcessorx/ModelProcessorx.h"
 #include "./objects.h"
 #include "../include/include.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 
 
Index: issm/trunk/src/c/objects/objects.h
===================================================================
--- issm/trunk/src/c/objects/objects.h	(revision 3912)
+++ issm/trunk/src/c/objects/objects.h	(revision 3913)
@@ -79,7 +79,29 @@
 
 /*Bamg: */
+#include "./Bamg/BamgOpts.h"
 #include "./Bamg/BamgGeom.h"
 #include "./Bamg/BamgMesh.h"
-#include "./Bamg/BamgOpts.h"
+#include "./Bamg/Metric.h"
+#include "./Bamg/DoubleAndInt.h"
+#include "./Bamg/Direction.h"
+#include "./Bamg/MeshVertex.h"
+#include "./Bamg/TriangleAdjacent.h"
+#include "./Bamg/Edge.h"
+#include "./Bamg/GeometricalVertex.h"
+#include "./Bamg/GeometricalEdge.h"
+#include "./Bamg/Curve.h"
+#include "./Bamg/Triangle.h"
+#include "./Bamg/ListofIntersectionTriangles.h"
+#include "./Bamg/GeometricalSubDomain.h"
+#include "./Bamg/SubDomain.h"
+#include "./Bamg/VertexOnGeom.h"
+#include "./Bamg/VertexOnVertex.h"
+#include "./Bamg/VertexOnEdge.h"
+#include "./Bamg/CrackedEdge.h"
+#include "./Bamg/Triangles.h"
+#include "./Bamg/Geometry.h"
+#include "./Bamg/QuadTree.h"
+#include "./Bamg/SetOfE4.h"
+
 
 #endif
Index: issm/trunk/src/c/shared/Bamg/Abs.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/Abs.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/Abs.h	(revision 3913)
@@ -0,0 +1,9 @@
+#ifndef _BAMGABS_H_
+#define _BAMGABS_H_
+
+namespace bamg {
+
+	template<class T> inline T Abs (const T &a){return a <0 ? -a : a;}
+
+}
+#endif
Index: issm/trunk/src/c/shared/Bamg/BigPrimeNumber.cpp
===================================================================
--- issm/trunk/src/c/shared/Bamg/BigPrimeNumber.cpp	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/BigPrimeNumber.cpp	(revision 3913)
@@ -0,0 +1,33 @@
+#include "./BigPrimeNumber.h"
+
+namespace bamg {
+
+	long BigPrimeNumber(long n){
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Mesh2.cpp/AGoodNumberPrimeWith)*/
+
+		//list of big prime numbers
+		const long BigPrimeNumber[] ={ 567890359L,
+			567890431L,  567890437L,  567890461L,  567890471L,
+			567890483L,  567890489L,  567890497L,  567890507L,
+			567890591L,  567890599L,  567890621L,  567890629L , 0};
+
+		//initialize o and pi
+		long o =0;
+		long pi=BigPrimeNumber[1];
+
+		//loop until BigPrimeNumber[i]==0 (end of BigPrimeNumber)
+		for (int i=0; BigPrimeNumber[i]; i++){
+
+			//compute r, rest of the remainder of the division of BigPrimeNumber[i] by n
+			long r = BigPrimeNumber[i] % n;
+
+			/*compute oo = min ( r , n-r , |n - 2r|, |n-3r|)*/
+			long oo =Min(Min(r,n-r),Min(Abs(n-2*r),Abs(n-3*r)));
+			if ( o < oo){
+				o=oo;
+				pi=BigPrimeNumber[i];
+			}
+		}
+		return pi; 
+	}
+}
Index: issm/trunk/src/c/shared/Bamg/BigPrimeNumber.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/BigPrimeNumber.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/BigPrimeNumber.h	(revision 3913)
@@ -0,0 +1,12 @@
+#ifndef _BIGPRIMENUMBER_H_
+#define _BIGPRIMENUMBER_H_
+
+#include "./Abs.h"
+#include "./extrema.h"
+
+namespace bamg {
+
+	long BigPrimeNumber(long n);
+
+}
+#endif
Index: issm/trunk/src/c/shared/Bamg/BinaryRand.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/BinaryRand.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/BinaryRand.h	(revision 3913)
@@ -0,0 +1,18 @@
+#ifndef _BINARYRAND_H_
+#define _BINARYRAND_H_
+
+#include <cstdlib>
+
+/*Return 1 or 0 randomly*/
+inline int BinaryRand(){
+	#ifdef RAND_MAX
+		/*RAND_MAX is defined by stdlib.h and is usually 32767*/
+		const long HalfRandMax = RAND_MAX/2;
+		return rand() < HalfRandMax;
+	#else
+		/*For sun machines, RAND_MAX is not defined, use 2^24*/
+		return rand() & 16384;
+	#endif
+} 
+
+#endif
Index: issm/trunk/src/c/shared/Bamg/Exchange.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/Exchange.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/Exchange.h	(revision 3913)
@@ -0,0 +1,6 @@
+#ifndef _EXCHANGE_H_
+#define _EXCHANGE_H_
+
+template<class T> inline void Exchange (T &a,T &b) {T c=a;a=b;b=c;}
+
+#endif
Index: issm/trunk/src/c/shared/Bamg/HeapSort.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/HeapSort.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/HeapSort.h	(revision 3913)
@@ -0,0 +1,67 @@
+#ifndef _HEAPSORT_H_
+#define _HEAPSORT_H_
+
+/*Sort a list of size n*/
+template<class T> inline void  HeapSort(T *c,long n){
+	int l,j,r,i;
+	T   crit;
+	c--;                    //the array must starts at 1 and not 0 
+	if(n<=1) return;        //return if size <=1
+	l=n/2+1;                //initialize l and r
+	r=n;
+	for(;;){
+		if(l<=1){
+			crit  =c[r];
+			c[r--]=c[1];
+			if (r==1){c[1]=crit; return;}
+		}
+		else  crit = c[--l]; 
+		j=l;
+		for(;;){
+			i=j;
+			j=2*j;
+			if  (j>r) {c[i]=crit;break;}
+			if ((j<r) && (c[j] < c[j+1])) j++;//c[j+1]> c[j] -> take j+1 instead of j (larger value)
+			if (crit < c[j]) c[i]=c[j];       //c[j]  > crit -> stock this large value in i(<j)
+			else{c[i]=crit;break;}            //c[j]  < crit -> stock crit in i (<j)
+		}
+	}
+}
+
+/*Sort a list of size n and returns ordering*/
+template<class T> inline void  HeapSort(int** porder,T* c,int n){
+	int  l,j,r,i;
+	T    crit;
+	int  pos;
+	int* order = new int[n];
+	for(i=0;i<n;i++) order[i]=i+1;
+	c--;                    //the array must starts at 1 and not 0 
+	order--;
+	if(n<=1) return;        //return if size <=1
+	l=n/2+1;                //initialize l and r
+	r=n;
+	for(;;){
+		if(l<=1){
+			crit  =c[r]; pos=order[r];
+			c[r--]=c[1]; order[r+1]=order[1];
+			if (r==1){
+				c[1]=crit; order[1]=pos;
+				order++;
+				*porder=order;
+				return;
+			}
+		}
+		else  {crit=c[--l]; pos=order[l];}
+		j=l;
+		for(;;){
+			i=j;
+			j=2*j;
+			if  (j>r) {c[i]=crit;order[i]=pos;break;}
+			if ((j<r) && (c[j] < c[j+1]))j++;
+			if (crit < c[j]) {c[i]=c[j];order[i]=order[j];}
+			else{c[i]=crit;order[i]=pos;break;}
+		}
+	}
+}
+
+#endif
Index: issm/trunk/src/c/shared/Bamg/Norm.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/Norm.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/Norm.h	(revision 3913)
@@ -0,0 +1,8 @@
+#ifndef _BAMGNORM_H_
+#define _BAMGNORM_H_
+
+#include <math.h>
+
+template<class T> inline double Norm(const T &a){return sqrt(a*a);}
+
+#endif
Index: issm/trunk/src/c/shared/Bamg/OppositeAngle.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/OppositeAngle.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/OppositeAngle.h	(revision 3913)
@@ -0,0 +1,12 @@
+#ifndef _OPPOSITEANGLE_H_
+#define _OPPOSITEANGLE_H_
+
+#include "../../objects/Bamg/include.h"
+
+/*Return the opposite angle modulo 2 Pi*/
+namespace bamg {
+	inline float  OppositeAngle(float  a){return a<0 ? fPi+a:a-fPi;}
+	inline double OppositeAngle(double a){return a<0 ?  Pi+a:a- Pi;}
+}
+
+#endif
Index: issm/trunk/src/c/shared/Bamg/det.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/det.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/det.h	(revision 3913)
@@ -0,0 +1,15 @@
+#ifndef _BAMGDET_H_
+#define _BAMGDET_H_
+
+#include "../../objects/Bamg/include.h"
+
+namespace bamg {
+
+	Icoor2 inline det(const I2 &a,const I2 & b,const I2 &c){
+		register  Icoor2 bax = b.x - a.x ,bay = b.y - a.y; 
+		register  Icoor2 cax = c.x - a.x ,cay = c.y - a.y; 
+		return  bax*cay - bay*cax;
+	}
+
+}
+#endif
Index: issm/trunk/src/c/shared/Bamg/extrema.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/extrema.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/extrema.h	(revision 3913)
@@ -0,0 +1,13 @@
+#ifndef _EXTREMA_H_
+#define _EXTREMA_H_
+
+namespace bamg {
+
+	template<class T> inline T Min (const T &a,const T &b){return a < b ? a : b;}
+	template<class T> inline T Max (const T &a,const T & b){return a > b ? a : b;}
+	template<class T> inline T Max3 (const T &a,const T & b,const T & c){return Max(Max(a,b),c);}
+	template<class T> inline T Min3 (const T &a,const T & b,const T & c){return Min(Min(a,b),c);}
+
+}
+
+#endif
Index: issm/trunk/src/c/shared/Bamg/shared.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/shared.h	(revision 3913)
+++ issm/trunk/src/c/shared/Bamg/shared.h	(revision 3913)
@@ -0,0 +1,18 @@
+/* \file shared.h
+ * \brief: header file for all shared  routines.
+ */
+
+
+#ifndef _SHAREDBamg_H_
+#define _SHAREDBamg_H_
+
+#include "Abs.h"
+#include "BigPrimeNumber.h"
+#include "BinaryRand.h"
+#include "det.h"
+#include "Exchange.h"
+#include "extrema.h"
+#include "HeapSort.h"
+#include "OppositeAngle.h"
+
+#endif
Index: issm/trunk/src/c/shared/shared.h
===================================================================
--- issm/trunk/src/c/shared/shared.h	(revision 3912)
+++ issm/trunk/src/c/shared/shared.h	(revision 3913)
@@ -19,4 +19,5 @@
 #include "String/sharedstring.h" //to avoid confusion with <string.h> standard header file
 #include "Threads/issm_threads.h"
+#include "Bamg/shared.h"
 
 
Index: issm/trunk/src/c/solutions/ControlInitialization.cpp
===================================================================
--- issm/trunk/src/c/solutions/ControlInitialization.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/ControlInitialization.cpp	(revision 3913)
@@ -8,5 +8,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "./solutions.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 
 void ControlInitialization(Model* model){
Index: issm/trunk/src/c/solutions/ControlRestart.cpp
===================================================================
--- issm/trunk/src/c/solutions/ControlRestart.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/ControlRestart.cpp	(revision 3913)
@@ -5,5 +5,5 @@
 
 #include "./solutions.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 
Index: issm/trunk/src/c/solutions/balancedthickness.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 3913)
@@ -13,5 +13,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../include/include.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 #include "./solutions.h"
 
Index: issm/trunk/src/c/solutions/balancedthickness2.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 3913)
@@ -14,5 +14,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../include/include.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 #include "./solutions.h"
 
Index: issm/trunk/src/c/solutions/balancedthickness2_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness2_core.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/balancedthickness2_core.cpp	(revision 3913)
@@ -9,5 +9,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "./solutions.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 
 DataSet* balancedthickness2_core(Model* model){
Index: issm/trunk/src/c/solutions/balancedthickness_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness_core.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/balancedthickness_core.cpp	(revision 3913)
@@ -9,5 +9,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "./solutions.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 
 DataSet* balancedthickness_core(Model* model){
Index: issm/trunk/src/c/solutions/balancedvelocities.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 3913)
@@ -14,5 +14,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../include/include.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 #include "./solutions.h"
 
Index: issm/trunk/src/c/solutions/balancedvelocities_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedvelocities_core.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/balancedvelocities_core.cpp	(revision 3913)
@@ -8,5 +8,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "./solutions.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 
 DataSet* balancedvelocities_core(Model* model){
Index: issm/trunk/src/c/solutions/control_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/control_core.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/control_core.cpp	(revision 3913)
@@ -4,5 +4,5 @@
 
 #include "./solutions.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 
Index: issm/trunk/src/c/solutions/convergence.cpp
===================================================================
--- issm/trunk/src/c/solutions/convergence.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/convergence.cpp	(revision 3913)
@@ -4,5 +4,5 @@
 
 #include "../objects/objects.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 
Index: issm/trunk/src/c/solutions/diagnostic.cpp
===================================================================
--- issm/trunk/src/c/solutions/diagnostic.cpp	(revision 3912)
+++ issm/trunk/src/c/solutions/diagnostic.cpp	(revision 3913)
@@ -14,5 +14,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../include/include.h"
-#include "../modules.h"
+#include "../modules/modules.h"
 #include "./solutions.h"
 
